# KDChartPieDiagram.cpp File Reference

`#include <QDebug>`
`#include <QPainter>`
`#include <QStack>`
`#include "KDChartAttributesModel.h"`
`#include "KDChartPaintContext.h"`
`#include "KDChartPieDiagram.h"`
`#include "KDChartPieDiagram_p.h"`
`#include "KDChartPieAttributes.h"`
`#include "KDChartThreeDPieAttributes.h"`
`#include "KDChartPainterSaver_p.h"`
`#include "KDChartDataValueAttributes.h"`
`#include <KDABLibFakes>`

Include dependency graph for KDChartPieDiagram.cpp:

Go to the source code of this file.

## Defines

#define | d d_func()

## Functions

QRectF | buildReferenceRect (const PolarCoordinatePlane *plane)

## Define Documentation

#define d d_func()

| Definition at line 50 of file KDChartPieDiagram.cpp.

## Function Documentation

QRectF buildReferenceRect | ( | const PolarCoordinatePlane * | plane | ) | `[static]`

Definition at line 113 of file KDChartPieDiagram.cpp.

References KDChart::PolarCoordinatePlane::translate().

Referenced by KDChart::PieDiagram::paint().

    00114 {
    00115     QRectF contentsRect;
    00116 //qDebug() << "..........................................";
    00117     QPointF referencePointAtTop = plane->translate( QPointF( 1, 0 ) );
    00118     QPointF temp = plane->translate( QPointF( 0, 0 ) ) - referencePointAtTop;
    00119     const double offset = temp.y();
    00120     referencePointAtTop.setX( referencePointAtTop.x() - offset );
    00121     contentsRect.setTopLeft( referencePointAtTop );
    00122     contentsRect.setBottomRight( referencePointAtTop + QPointF( 2*offset, 2*offset) );
    00123 //qDebug() << contentsRect;
    00124     return contentsRect;
    00125 }